package com.cedarsoft.spring.rcp;

import org.jetbrains.annotations.NotNull;
import org.springframework.beans.factory.FactoryBean;

import java.util.Currency;
import java.util.Locale;

/**
 * Factory that creates the currency symbol for the current locale
 */
public class CurrencySymbolFactory implements FactoryBean {
  @Override
  @NotNull
  public String getObject() throws Exception {
    return Currency.getInstance( Locale.getDefault() ).getSymbol( Locale.getDefault() );
  }

  @Override
  public Class<String> getObjectType() {
    return String.class;
  }

  @Override
  public boolean isSingleton() {
    return true;
  }
}
