package com.cedarsoft.spring.rcp;

import org.jetbrains.annotations.Nullable;
import org.springframework.richclient.application.config.ApplicationWindowConfigurer;
import org.springframework.richclient.application.config.DefaultApplicationLifecycleAdvisor;
import org.springframework.richclient.application.docking.jide.JideApplicationLifecycleAdvisor;

import java.awt.Dimension;

/**
 * Extended lifecycle advisor
 */
//public class ExtendedLifecycleAdvisor extends JideApplicationLifecycleAdvisor {
public class ExtendedLifecycleAdvisor extends DefaultApplicationLifecycleAdvisor {
  @Nullable
  private Dimension initialSize;

  @Override
  public void onPreWindowOpen( ApplicationWindowConfigurer configurer ) {
    super.onPreWindowOpen( configurer );
    // Uncomment to hide the menubar, toolbar, or alter window size...
    // configurer.setShowMenuBar(false);
    // configurer.setShowToolBar(false);
    if ( initialSize != null ) {
      configurer.setInitialSize( initialSize );
    }
  }

  @Override
  public void onShutdown() {
    super.onShutdown();
  }

  @Nullable
  public Dimension getInitialSize() {
    return initialSize;
  }

  public void setInitialSize( @Nullable Dimension initialSize ) {
    this.initialSize = initialSize;
  }
}
