package com.cedarsoft.spring.rcp;

import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;
import org.springframework.richclient.components.FileChooser;

import java.io.File;

/**
 *
 */
public class FileSuffixProcessor implements FileChooser.PathProcessor {
  @NotNull
  @NonNls
  private final String suffix;

  public FileSuffixProcessor( @NotNull String suffix ) {
    this.suffix = suffix;
  }

  @Override
  @NotNull
  @NonNls
  public String process( @NotNull File path ) {
    if ( path.getName().endsWith( suffix ) ) {
      return path.getAbsolutePath();
    }

    return path.getAbsolutePath() + '.' + suffix;
  }
}
