package com.cedarsoft.spring.rcp;

import com.jidesoft.plaf.LookAndFeelFactory;
import org.springframework.beans.factory.InitializingBean;

import javax.swing.UIManager;

/**
 * Look and feel configurer that sets the nimbus LF
 */
public class NimbusLooksConfigurer implements InitializingBean {
  @Override
  public void afterPropertiesSet() throws Exception {
    for ( UIManager.LookAndFeelInfo lookAndFeelInfo : UIManager.getInstalledLookAndFeels() ) {
      if ( lookAndFeelInfo.getName().contains( "Nimbus" ) ) {
        UIManager.setLookAndFeel( lookAndFeelInfo.getClassName() );
        new LookAndFeelFactory.NimbusInitializer().initialize( UIManager.getLookAndFeelDefaults() );
        return;
      }
    }
  }
}
