package com.cedarsoft.spring.rcp;

import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;

/**
 * Contains the references to the default configuration files provided by this integration.
 */
public interface SpringConfiguration {
  /**
   * Contains common ui configurations - should be used.
   */
  @NonNls
  @NotNull
  String COMMONS_UI = "/com/cedarsoft/spring/rcp/commons-ui.spr.xml";

  /**
   * Contains default ui configurations - may be used, should be copied.
   */
  @NotNull
  @NonNls
  String DEFAULTS_UI = "/com/cedarsoft/spring/rcp/defaults-ui.spr.xml";

  /**
   * Contains default ui configurations - may be used, should be copied.
   */
  @NotNull
  @NonNls
  String DEFAULTS_UI_NON_JIDE = "/com/cedarsoft/spring/rcp/defaults-ui-non-jide.spr.xml";

  /**
   * Contains default ui configurations - may be used, should be copied.
   */
  @NotNull
  @NonNls
  String ABSTRACT_UI = "/com/cedarsoft/spring/rcp/abstract-ui.spr.xml";

  /**
   * Contains default ui configurations (without Jide support) - may be used.
   */
  @NotNull
  @NonNls
  String ABSTRACT_UI_NON_JIDE = "/com/cedarsoft/spring/rcp/abstract-ui-non-jide.spr.xml";

  /**
   * Contains common beans configurations - should be used.
   */
  @NotNull
  @NonNls
  String COMMONS_BEANS = "/com/cedarsoft/spring/rcp/commons-beans.spr.xml";

  /**
   * Contains default conversion strategies - may be used, should be copied.
   */
  @NonNls
  @NotNull
  String DEFAULTS_CONVERSIONS = "/com/cedarsoft/spring/rcp/defaults-conversions.spr.xml";

  /**
   * Contains abstract conversion strategies - should be used.
   */
  @NonNls
  @NotNull
  String ABSTRACT_CONVERSIONS = "/com/cedarsoft/spring/rcp/abstract-conversions.spr.xml";

  /**
   * Contains the default bindings - may be used, should be copied.
   */
  @NonNls
  @NotNull
  String DEFAULTS_BINDINGS = "/com/cedarsoft/spring/rcp/defaults-bindings.spr.xml";

  /**
   * Abstract bindings - should be used.
   */
  @NonNls
  @NotNull
  String ABSTRACT_BINDINGS = "/com/cedarsoft/spring/rcp/abstract-bindings.spr.xml";

  /**
   * Contains the default application configuration - may be used, should be copied.
   */
  @NonNls
  @NotNull
  String COMMONS_APPLICATION = "/com/cedarsoft/spring/rcp/commons-application.spr.xml";

  @NonNls
  @NotNull
  String ABSTRACT_APPLICATION = "/com/cedarsoft/spring/rcp/abstract-application.spr.xml";

  /**
   * Default startup configuration - may be used, should be copied.
   */
  @NonNls
  @NotNull
  String DEFAULT_STARTUP = "/com/cedarsoft/spring/rcp/default-startup.spr.xml";


  @NonNls
  @NotNull
  String DEFAULTS_EXCEPTIONS = "/com/cedarsoft/spring/rcp/defaults-exceptions.spr.xml";

  @NonNls
  @NotNull
  String ABSTRACT_EXCEPTIONS = "/com/cedarsoft/spring/rcp/abstract-exceptions.spr.xml";
}
