package com.cedarsoft.spring.rcp.beans;

import com.cedarsoft.lookup.Lookup;
import org.jetbrains.annotations.NotNull;

/**
 * Is capable of displaying several beans.
 */
public interface BeansDisplay {
  /**
   * Opens a ui component (view or editor or dialog or something else)
   * where the beans are shown. Filtering may be done depending on the context.
   * <p/>
   * This method should *not* open a modal dialog. Views and editors are preferred.
   *
   * @param context the context
   */
  void show( @NotNull Lookup context );
}