package com.cedarsoft.spring.rcp.beans.factory;

import com.cedarsoft.spring.rcp.BeanFactory;
import org.jetbrains.annotations.Nullable;

/**
 * Configuration for the UI of business objects.
 * Only this implementation should be necessary for simple business objects
 *
 * @param <T> the type
 */
public interface UiAccessBuilderConfiguration<T> extends UiAccessBuilder.AbstractConfiguration<T> {
  /**
   * Returns the bean factory
   *
   * @return the bean factory or null if the creation of beans is not supported
   */
  @Nullable
  BeanFactory<T> getBeanFactory();
}
