package com.cedarsoft.spring.rcp.commands;

import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.NonNls;
import org.springframework.richclient.wizard.Wizard;
import com.cedarsoft.CanceledException;

/**
 * A wizard command
 *
 * @param <W> the wizard type
 */
public class WizardCommand<W extends Wizard> extends AbstractWizardCommand<W> {
  @NotNull
  private final WizardFactory<W> factory;

  public WizardCommand( @NotNull @NonNls String commandId, @NotNull WizardFactory<W> factory ) {
    super( commandId );
    this.factory = factory;
  }

  @NotNull
  @Override
  protected W createWizard() throws CanceledException {
    return factory.createWizard();
  }
}
