package com.cedarsoft.spring.rcp.conversion;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jetbrains.annotations.Nullable;
import org.joda.time.DateTime;
import org.joda.time.LocalDate;
import org.joda.time.base.AbstractInstant;
import org.springframework.binding.convert.ConversionContext;
import org.springframework.binding.convert.support.ConversionServiceAwareConverter;

import java.util.Date;

/**
 *
 */
public class JodaToDateConverter extends ConversionServiceAwareConverter {
  private static final Log log = LogFactory.getLog( JodaToDateConverter.class );

  @Override
  @Nullable
  protected Object doConvert( Object source, Class targetClass, ConversionContext context ) throws Exception {
    if ( source == null ) {
      return null;
    }

    if ( source instanceof AbstractInstant ) {
      return ( ( AbstractInstant ) source ).toDate();
    }

    if ( source instanceof LocalDate ) {
      return ( ( LocalDate ) source ).toDateTimeAtStartOfDay().toDate();
    }
    throw new IllegalStateException( "??? " + source.getClass().getName() + ' ' + source );
  }

  @Override
  public Class[] getSourceClasses() {
    return new Class[]{AbstractInstant.class, LocalDate.class, DateTime.class};
  }

  @Override
  public Class[] getTargetClasses() {
    return new Class[]{Date.class};
  }
}
