package com.cedarsoft.spring.rcp.conversion;

import org.springframework.binding.convert.ConversionContext;
import org.springframework.binding.convert.support.ConversionServiceAwareConverter;

import java.util.Date;

/**
 *
 */
public class LongToDateConverter extends ConversionServiceAwareConverter {
  @Override
  protected Object doConvert( Object source, Class targetClass, ConversionContext context ) throws Exception {
    if ( ( Long ) source == 0 ) {
      return null;
    }

    return new Date( ( Long ) source );
  }

  @Override
  public Class[] getSourceClasses() {
    return new Class[]{Long.class};
  }

  @Override
  public Class[] getTargetClasses() {
    return new Class[]{Date.class};
  }
}