package com.cedarsoft.spring.rcp.conversion;

import com.cedarsoft.spring.rcp.joda.JodaSupport;
import org.joda.time.Period;
import org.joda.time.ReadablePeriod;
import org.springframework.binding.convert.ConversionContext;
import org.springframework.binding.convert.support.ConversionServiceAwareConverter;

/**
 *
 */
public class PeriodConverter extends ConversionServiceAwareConverter {
  @Override
  protected Object doConvert( Object source, Class targetClass, ConversionContext context ) throws Exception {

    if ( source instanceof String ) {
      return JodaSupport.PERIOD_FORMAT.parsePeriod( ( String ) source );
    }

    if ( source instanceof Period ) {
      return JodaSupport.PERIOD_FORMAT.print( ( ReadablePeriod ) source );
    }

    throw new IllegalStateException( "??? " + source );
  }

  @Override
  public Class[] getSourceClasses() {
    return new Class[]{String.class, Period.class};
  }

  @Override
  public Class[] getTargetClasses() {
    return new Class[]{String.class, Period.class};
  }
}
