package com.cedarsoft.spring.rcp.conversion;

import org.joda.time.LocalTime;
import org.joda.time.format.DateTimeFormat;
import org.springframework.binding.convert.ConversionContext;
import org.springframework.binding.convert.support.ConversionServiceAwareConverter;

/**
 *
 */
public class TimeConverter extends ConversionServiceAwareConverter {
  @Override
  protected Object doConvert( Object source, Class targetClass, ConversionContext context ) throws Exception {
    if ( source instanceof String ) {
      return DateTimeFormat.shortTime().parseDateTime( ( String ) source ).toLocalTime();
    }

    if ( source instanceof LocalTime ) {
      return DateTimeFormat.shortTime().print( ( LocalTime ) source );
    }

    throw new IllegalArgumentException( "??? " + source );
  }

  @Override
  public Class[] getSourceClasses() {
    return new Class[]{String.class, LocalTime.class};
  }

  @Override
  public Class[] getTargetClasses() {
    return new Class[]{String.class, LocalTime.class};
  }
}
