package com.cedarsoft.spring.rcp.dialog;

import org.springframework.richclient.dialog.ConfirmationDialog;

import java.awt.Window;

/**
 * Extended confirmation dialog with yes, no, cancel options...
 */
public abstract class DefaultConfirmationDialog extends ConfirmationDialog {
  protected DefaultConfirmationDialog() {
  }

  protected DefaultConfirmationDialog( String title, String message ) {
    super( title, message );
  }

  protected DefaultConfirmationDialog( String title, Window parent, String message ) {
    super( title, parent, message );
  }

  /**
   * @noinspection RefusedBequest
   */
  @Override
  protected String getCancelCommandId() {
    return DEFAULT_CANCEL_COMMAND_ID;
  }

  /**
   * @noinspection RefusedBequest
   */
  @Override
  protected String getFinishCommandId() {
    return DEFAULT_FINISH_COMMAND_ID;
  }
}