package com.cedarsoft.spring.rcp.dialog;

import org.jetbrains.annotations.NotNull;
import org.springframework.richclient.command.AbstractCommand;
import org.springframework.richclient.command.ActionCommand;
import org.springframework.richclient.dialog.ConfirmationDialog;

import java.awt.Window;

/**
 * Extended confirmation dialog with yes, no, cancel options...
 */
public abstract class ExtendedConfirmationDialog extends ConfirmationDialog {
  protected ExtendedConfirmationDialog() {
  }

  protected ExtendedConfirmationDialog( String title, String message ) {
    super( title, message );
  }

  protected ExtendedConfirmationDialog( String title, Window parent, String message ) {
    super( title, parent, message );
  }

  /**
   * @noinspection RefusedBequest
   */
  @Override
  protected Object[] getCommandGroupMembers() {
    return new AbstractCommand[]{getFinishCommand(), getNoCommand(), getCancelCommand()};
  }

  /**
   * @noinspection RefusedBequest
   */
  @Override
  protected String getCancelCommandId() {
    return DEFAULT_CANCEL_COMMAND_ID;
  }

  @NotNull
  public ActionCommand getNoCommand() {
    return noCommand;
  }

  @NotNull
  private ActionCommand noCommand = new ActionCommand( "noCommand" ) {
    @Override
    public void doExecuteCommand() {
      onNo();
      ExtendedConfirmationDialog.super.onCancel();
    }
  };

  protected abstract void onNo();
}
