package com.cedarsoft.spring.rcp.dialog;

import com.cedarsoft.CommitableObjectAccess;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

/**
 * Creates a dialog for a given object
 *
 * @param <T> the type of object this factory creates dialogs for
 */
public interface FormDialogFactory<T> {
  /**
   * Creates the form dialog
   *
   * @param selectedObject the selected object
   * @param objectAccess   the object access
   * @return the dialog the dialog
   */
  @NotNull
  FormDialog<T> createDialog( @Nullable T selectedObject, @NotNull CommitableObjectAccess<T> objectAccess );
}
