package com.cedarsoft.spring.rcp.editor;

import com.cedarsoft.spring.SpringSupport;
import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;
import org.springframework.richclient.command.ActionCommand;

/**
 * Shows an object within a new editor
 */
public abstract class OpenInEditorCommand extends ActionCommand {
  /**
   * Creates a new command with the id "openInEditorCommand"
   */
  protected OpenInEditorCommand() {
    super( "openInEditorCommand" );
  }

  /**
   * Creates a new command with the given id
   *
   * @param commandId the command id
   */
  protected OpenInEditorCommand( @NotNull @NonNls String commandId ) {
    super( commandId );
  }

  @Override
  protected void doExecuteCommand() {
    SpringSupport.INSTANCE.openEditor( getCurrentObject() );
  }

  /**
   * Returns the current object
   *
   * @return the current object
   */
  @NotNull
  protected abstract Object getCurrentObject();
}
