package com.cedarsoft.spring.rcp.editor;

import com.cedarsoft.spring.rcp.table.ExtendedObjectTable;
import com.cedarsoft.spring.rcp.table.ObjectTable;
import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;

/**
 * Opens the currently selected object from an {@link ObjectTable}.
 */
public class OpenSelectedObjectCommand extends OpenInEditorCommand {
  private ObjectTable<?> objectTable;

  public OpenSelectedObjectCommand() {
  }

  public OpenSelectedObjectCommand( @NotNull @NonNls String commandId ) {
    super( commandId );
  }

  @Override
  @NotNull
  protected Object getCurrentObject() {
    if ( objectTable == null ) {
      throw new IllegalStateException( "object table not initialized properly" );
    }
    return objectTable.getSelectedObject();
  }

  /**
   * Sets the object table
   *
   * @param objectTable the object table
   */
  public void setObjectTable( @NotNull ObjectTable<?> objectTable ) {
    this.objectTable = objectTable;
  }
}
