package com.cedarsoft.spring.rcp.events;

import org.jetbrains.annotations.NotNull;

import java.util.EventObject;

/**
 * A selection event. This event is in the communication between the details tree and its pane
 */
public class DetailsTreeSelectionEvent extends EventObject {
  @NotNull
  private final Type type;

  public DetailsTreeSelectionEvent( @NotNull Type type, @NotNull Object source ) {
    super( source );
    this.type = type;
  }

  @NotNull
  public Type getType() {
    return type;
  }

  @NotNull
  public Object getObject() {
    return getSource();
  }

  public enum Type {
    UNSELECTED,
    SELECTED
  }
}
