package com.cedarsoft.spring.rcp.events;

import com.cedarsoft.lookup.Lookup;
import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;
import org.springframework.richclient.application.event.LifecycleApplicationEvent;

/**
 * This event will show beans of a given type
 */
public class ShowBeansEvent extends LifecycleApplicationEvent {
  @NotNull
  @NonNls
  public static final String TYPE = "showBeans";
  @NotNull
  private final Class<?> beanType;
  @NotNull
  private final Lookup context;

  public ShowBeansEvent( @NotNull Object source, @NotNull Class<?> beanType, @NotNull  Lookup context ) {
    super( TYPE, source );
    this.beanType = beanType;
    this.context = context;
  }

  @NotNull
  public Class<?> getBeanType() {
    return beanType;
  }

  @NotNull
  public Lookup getContext() {
    return context;
  }
}
