package com.cedarsoft.spring.rcp.forms;

import org.jetbrains.annotations.NotNull;
import org.springframework.binding.form.ValidatingFormModel;

/**
 * Creates a form model
 *
 * @param <T> the type this factory creates form models for
 */
public interface FormModelFactory<T> {
  /**
   * Creates the form model
   *
   * @param formObject the form object that model is created for
   * @return the form model
   */
  @NotNull
  ValidatingFormModel createFormModel( @NotNull T formObject );
}
