package com.cedarsoft.spring.rcp.hierarchy;

import com.cedarsoft.lookup.Lookup;
import org.jetbrains.annotations.NotNull;

/**
 * Provides the details that are visualized within the details view.
 */
public interface DetailsProvider<P> {
  /**
   * Creates a lookup that contains all details for the given parent.
   * This method may be called multiple times for a given parent and should return
   * the same instances every time.
   *
   * @param parent the parent
   * @return the details
   */
  @NotNull
  Lookup getDetails( @NotNull P parent );
}
