package com.cedarsoft.spring.rcp.hierarchy;

import com.cedarsoft.lookup.Lookup;
import org.jetbrains.annotations.NotNull;

/**
 *
 */
public interface TitleProvider<P> {
  /**
   * Creates a lookup that contains all title information for the given parent.
   * This method may be called multiple times for a given parent and should return
   * the same instances every time.
   *
   * @param parent the parent
   * @return the title
   */
  @NotNull
  Lookup getTitle( @NotNull P parent );
}