package com.cedarsoft.spring.rcp.id;

import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;

/**
 * Default id strategy
 */
public class DefaultIdStrategy implements IdStrategy {
  @NotNull
  @NonNls
  private final String baseId;

  public DefaultIdStrategy( @NonNls @NotNull String baseId ) {
    this.baseId = baseId;
  }

  @Override
  @NotNull
  public String createEditorId() {
    return baseId + "Editor";
  }

  @Override
  @NotNull
  @NonNls
  public String getBaseId() {
    return baseId;
  }

  @Override
  @NotNull
  @NonNls
  public String createTableId() {
    return getPlural();
  }

  @Override
  @NotNull
  @NonNls
  public String createDialogId() {
    return baseId + "Properties";
  }

  @Override
  @NotNull
  @NonNls
  public String createFormId() {
    return baseId + "Form";
  }

  @Override
  @NotNull
  @NonNls
  public String createTablePanelId() {
    return getPlural();
  }

  @Override
  @NotNull
  @NonNls
  public String createViewId() {
    return getPlural() + "View";
  }

  @NotNull
  @NonNls
  private String getPlural() {
    return baseId + 's';
  }
}
