package com.cedarsoft.spring.rcp.prefetch;

import org.jetbrains.annotations.NotNull;

/**
 * Abstract implementation
 *
 * @param <T> the type for this prefetcher
 */
public abstract class AbstractObjectPrefetcher<T> implements ObjectPrefetcher<T> {
  @NotNull
  private final Class<T> type;

  /**
   * Creates a new prefetcher
   *
   * @param type the type
   */
  protected AbstractObjectPrefetcher( @NotNull Class<T> type ) {
    this.type = type;
  }

  @Override
  public boolean isResponsible( @NotNull Object object ) {
    return type.isAssignableFrom( object.getClass() );
  }
}
