package com.cedarsoft.spring.rcp.table.renderer;

import org.jetbrains.annotations.NotNull;
import org.joda.time.DateTime;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;

/**
 *
 */
public class DateTimeTableCellRenderer extends AbstractTableCellRenderer<DateTime> {
  private boolean showTime;
  @NotNull
  private DateTimeFormatter shortDateTime = DateTimeFormat.shortDateTime();
  @NotNull
  private DateTimeFormatter shortDate = DateTimeFormat.shortDate();

  public DateTimeTableCellRenderer() {
    this( true );
  }

  public DateTimeTableCellRenderer( boolean showTime ) {
    super( DateTime.class );
    this.showTime = showTime;
  }

  @Override
  @NotNull
  public String format( @NotNull DateTime object ) {
    if ( showTime ) {
      return shortDateTime.print( object );
    } else {
      return shortDate.print( object );
    }
  }
}