package com.cedarsoft.spring.rcp.table.renderer;

import com.cedarsoft.spring.rcp.table.renderer.AbstractTableCellRenderer;
import org.jetbrains.annotations.NotNull;
import org.joda.time.Interval;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;

/**
 *
 */
public class IntervalTableCellRenderer extends AbstractTableCellRenderer<Interval> {
  @NotNull
  private final DateTimeFormatter format = DateTimeFormat.shortDate();

  public IntervalTableCellRenderer() {
    super( Interval.class );
  }

  @Override
  @NotNull
  protected String format( @NotNull Interval object ) {
    return format.print( object.getStart() ) + " - " + format.print( object.getEnd() );
  }
}