package com.cedarsoft.spring.rcp.table.renderer;

import com.cedarsoft.spring.rcp.table.renderer.AbstractTableCellRenderer;
import org.jetbrains.annotations.NotNull;

import java.math.BigDecimal;
import java.text.NumberFormat;

/**
 *
 */
public class PercentageTableCellRenderer extends AbstractTableCellRenderer<BigDecimal> {
  public PercentageTableCellRenderer() {
    super( BigDecimal.class, true );
  }

  @Override
  @NotNull
  protected String format( @NotNull BigDecimal object ) {
    NumberFormat format = NumberFormat.getPercentInstance();
    format.setMinimumFractionDigits( 4 );
    format.setMaximumFractionDigits( 4 );

    return format.format( object.doubleValue() );
  }
}
