package com.cedarsoft.spring.rcp.tbpanel;

import com.cedarsoft.history.ObservableObjectAccess;
import org.jetbrains.annotations.NotNull;

/**
 * Factory for table based panels
 *
 * @param <T> the type
 */
public interface ObjectTablePanelFactory<T> {
  /**
   * Creates the panel for the given object access
   *
   * @param objectAccess the object access
   * @return the created panel
   */
  ObjectTablePanel<T> createPanel( @NotNull ObservableObjectAccess<T> objectAccess );
}