package com.cedarsoft.spring.rcp.tbpanel;

import org.jetbrains.annotations.NotNull;
import org.springframework.binding.value.ValueModel;
import org.springframework.richclient.application.PageComponentContext;
import org.springframework.richclient.command.ActionCommand;

import java.util.Collection;

/**
 * Provides commands for a table based panel.
 */
public interface SidePanelCommandsProvider {
  /**
   * Returns the commands
   *
   * @param selectionHolder the selection holder model
   * @return the commands
   */
  @NotNull
  Collection<? extends ActionCommand> getCommands( @NotNull ValueModel selectionHolder );

  /**
   * Registers the local command executors
   *
   * @param context the context
   */
  void registerLocalCommandExecutors( @NotNull PageComponentContext context );
}
