package com.cedarsoft.spring.rcp.tbpanel.aspects;

import com.cedarsoft.history.ObservableObjectAccess;
import com.cedarsoft.lookup.Lookups;
import com.cedarsoft.spring.rcp.beans.BeanAgent;
import org.jetbrains.annotations.NotNull;

import javax.swing.JComponent;

/**
 * Default callback for add remove aspect
 *
 * @param <T>
 */
public class DefaultAddRemoveCallback<T> implements AddRemoveAspect.Callback<T> {
  @NotNull
  private final ObservableObjectAccess<T> objectAccess;
  @NotNull
  private final JComponent parent;
  @NotNull
  protected final BeanAgent<T> agent;

  /**
   * Creates a new callback
   *
   * @param objectAccess the object access
   * @param agent        the agent
   * @param parent       the panel
   */
  public DefaultAddRemoveCallback( @NotNull ObservableObjectAccess<T> objectAccess, @NotNull BeanAgent<T> agent, @NotNull JComponent parent ) {
    this.objectAccess = objectAccess;
    this.agent = agent;
    this.parent = parent;
  }

  @Override
  public void createNewEntry() {
    agent.create( objectAccess, Lookups.dynamicLookup( objectAccess, parent ) );
  }

  @Override
  public void removeEntry( @NotNull T entry ) {
    objectAccess.remove( entry );
  }
}
