package com.cedarsoft.spring.rcp.tbpanel.aspects;

import com.cedarsoft.spring.rcp.ComponentProvider;
import com.cedarsoft.spring.rcp.tbpanel.FilterFactory;
import com.cedarsoft.spring.rcp.tbpanel.ObjectTablePanel;
import org.jetbrains.annotations.NotNull;

import javax.swing.JComponent;

/**
 * Adds a filter using a filter factory.
 * @param <T> the type
 */
public class FilteredAspect<T> implements ObjectTablePanelAspect<T> {
  @NotNull
  private final FilterFactory<T> filterFactory;

  public FilteredAspect( @NotNull FilterFactory<T> filterFactory ) {
    this.filterFactory = filterFactory;
  }

  @Override
  public void apply( @NotNull final ObjectTablePanel<T> panel ) {
    panel.addHeadComponentProvider( new ComponentProvider() {
      @Override
      @NotNull
      public JComponent createComponent() {
        return filterFactory.createFilterPanel( panel.getObjectTable() );
      }
    } );
  }
}
