package com.cedarsoft.spring.rcp.view;

import com.cedarsoft.spring.rcp.views.ExtendedView;
import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;
import org.springframework.richclient.application.support.DefaultViewDescriptor;

import java.util.Map;

/**
 * Default factory for view descriptors...
 */
public class DefaultViewDescriptorFactory extends AbstractViewDescriptorFactory<DefaultViewDescriptor> {
  /**
   * Creates a new factory
   *
   * @param viewConfiguration the view configuration
   */
  public DefaultViewDescriptorFactory( @NotNull ViewConfiguration viewConfiguration ) {
    super( viewConfiguration );
  }

  /**
   * Creates a new factory
   *
   * @param viewClass      the view class
   * @param viewProperties the view properties
   */
  public DefaultViewDescriptorFactory( @NotNull Class<? extends ExtendedView> viewClass, @NotNull @NonNls Map<String, Object> viewProperties ) {
    super( viewClass, viewProperties );
  }

  @Override
  @NotNull
  protected DefaultViewDescriptor createPlainDescriptor() {
    return new DefaultViewDescriptor();
  }

  @Override
  protected void addCustomInitialization( @NotNull DefaultViewDescriptor descriptor ) {
  }
}
