package com.cedarsoft.spring.rcp.views;

import com.cedarsoft.lookup.Lookup;
import com.cedarsoft.spring.rcp.events.SelectionEvent;
import org.jetbrains.annotations.NotNull;
import org.springframework.richclient.application.PageComponentContext;
import org.springframework.richclient.application.support.AbstractView;

/**
 * Extended view that offers methods related to selection
 */
public abstract class ExtendedView extends AbstractView {
  @Override
  public void componentFocusGained() {
    getApplicationContext().publishEvent( new SelectionEvent( SelectionEvent.Type.SELECT, getSelectedObjects() ) );
    super.componentFocusGained();
    updateStatusBar();
  }

  @Override
  public void componentFocusLost() {
    super.componentFocusLost();
  }

  @Override
  protected void registerLocalCommandExecutors( PageComponentContext context ) {
    super.registerLocalCommandExecutors( context );
    updateStatusBar();
  }

  protected void updateStatusBar() {
  }

  /**
   * Returns the currently selected object
   *
   * @return the currently selected object
   */
  @NotNull
  protected abstract Lookup getSelectedObjects();
}
