package com.cedarsoft.utils.springrcp.beanlist;

import org.jetbrains.annotations.NotNull;

/**
 * A BeanDialog is a special dialog that is able to edit the properties of a bean.
 * <p/>
 * Date: 18.08.2006<br>
 * Time: 16:39:21<br>
 *
 * @author <a href="http://johannes-schneider.info">Johannes Schneider</a> -
 *         <a href="http://www.xore.de">Xore Systems</a>
 */
public interface BeanDialog<T> {
  /**
   * Is called before the dialog is show ({@link #showDialog()}).
   *
   * @param bean the bean that shall be edited
   */
  void setBean( @NotNull T bean );

  /**
   * Show the dialog.
   */
  void showDialog();

  /**
   * Is called when the dialog edits a bean that has newly be created and must be added on finish.
   *
   * @param isNew whether the bean is newly created
   */
  void setIsNew( boolean isNew );
}