package com.cedarsoft.utils.springrcp.beanlist.command;

import com.cedarsoft.utils.springrcp.beanlist.BeanDialog;
import com.cedarsoft.utils.springrcp.beanlist.BeanListView;
import com.cedarsoft.utils.springrcp.beanlist.ManagedBeanDialog;
import org.jetbrains.annotations.NotNull;
import org.springframework.richclient.command.ActionCommand;

/**
 * <p/>
 * Date: 29.08.2006<br>
 * Time: 14:49:56<br>
 *
 * @author <a href="http://johannes-schneider.info">Johannes Schneider</a> -
 *         <a href="http://www.xore.de">Xore Systems</a>
 */
public class PropertiesCommand<T> extends ActionCommand {
  private final BeanListView<T> listView;

  public PropertiesCommand( @NotNull BeanListView<T> listView ) {
    super( "propertiesAction" );
    this.listView = listView;
  }

  @Override
  protected void doExecuteCommand() {
    T bean = listView.getSelectedBean();
    if ( bean == null ) {
      throw new IllegalStateException( "Bean is null" );
    }

    BeanDialog<T> dialog = createBeanDialog();
    dialog.setBean( bean );
    dialog.showDialog();
  }

  private BeanDialog<T> createBeanDialog() {
    ManagedBeanDialog<T> dialog = new ManagedBeanDialog<T>( listView.getBeanManager(), listView.getBeanType() ) {
      @Override
      protected void activateBean() {
        listView.updateSelectionManager( this.getBean() );
      }
    };
    dialog.setParentComponent( listView.getContext().getWindow().getControl() );
    return dialog;
  }
}
