package com.cedarsoft.utils.springrcp.table;

import org.jetbrains.annotations.NotNull;
import org.springframework.context.MessageSource;
import org.springframework.richclient.application.Application;
import org.springframework.richclient.table.BeanTableModel;

/**
 * <p/>
 * Date: 21.08.2006<br>
 * Time: 22:32:56<br>
 *
 * @author <a href="http://johannes-schneider.info">Johannes Schneider</a> -
 *         <a href="http://www.xore.de">Xore Systems</a>
 */
public abstract class ExtendedBeanTableModel<T> extends BeanTableModel {
  private boolean editable;

  protected ExtendedBeanTableModel( @NotNull Class<T> aClass ) {
    this( aClass, false );
  }

  protected ExtendedBeanTableModel( @NotNull Class<T> aClass, boolean editable ) {
    super( aClass, ( MessageSource ) Application.instance().getApplicationContext().getBean( "messageSource" ) );
    this.editable = editable;
  }

  @Override
  protected boolean isCellEditableInternal( Object row, int columnIndex ) {
    return editable;
  }

  /**
   * Whether the table is editable
   *
   * @return true if it is editable, false otherwise
   */
  public boolean isEditable() {
    return editable;
  }
}
